function _aws_cdk_aws_comprehend_CfnFlywheelProps(p) {
    if (p == null)
        return;
    visitedObjects.add(p);
    try {
        if (!visitedObjects.has(p.dataSecurityConfig))
            _aws_cdk_aws_comprehend_CfnFlywheel_DataSecurityConfigProperty(p.dataSecurityConfig);
        if (p.tags != null)
            for (const o of p.tags)
                if (!visitedObjects.has(o))
                    require("@aws-cdk/core/.warnings.jsii.js")._aws_cdk_core_CfnTag(o);
    }
    finally {
        visitedObjects.delete(p);
    }
}
function _aws_cdk_aws_comprehend_CfnFlywheel(p) {
}
function _aws_cdk_aws_comprehend_CfnFlywheel_DataSecurityConfigProperty(p) {
}
function _aws_cdk_aws_comprehend_CfnFlywheel_DocumentClassificationConfigProperty(p) {
}
function _aws_cdk_aws_comprehend_CfnFlywheel_EntityRecognitionConfigProperty(p) {
}
function _aws_cdk_aws_comprehend_CfnFlywheel_EntityTypesListItemProperty(p) {
}
function _aws_cdk_aws_comprehend_CfnFlywheel_TaskConfigProperty(p) {
}
function _aws_cdk_aws_comprehend_CfnFlywheel_VpcConfigProperty(p) {
}
function print(name, deprecationMessage) {
    const deprecated = process.env.JSII_DEPRECATED;
    const deprecationMode = ["warn", "fail", "quiet"].includes(deprecated) ? deprecated : "warn";
    const message = `${name} is deprecated.\n  ${deprecationMessage.trim()}\n  This API will be removed in the next major release.`;
    switch (deprecationMode) {
        case "fail":
            throw new DeprecationError(message);
        case "warn":
            console.warn("[WARNING]", message);
            break;
    }
}
function getPropertyDescriptor(obj, prop) {
    const descriptor = Object.getOwnPropertyDescriptor(obj, prop);
    if (descriptor) {
        return descriptor;
    }
    const proto = Object.getPrototypeOf(obj);
    const prototypeDescriptor = proto && getPropertyDescriptor(proto, prop);
    if (prototypeDescriptor) {
        return prototypeDescriptor;
    }
    return {};
}
const visitedObjects = new Set();
class DeprecationError extends Error {
    constructor(...args) {
        super(...args);
        Object.defineProperty(this, "name", {
            configurable: false,
            enumerable: true,
            value: "DeprecationError",
            writable: false,
        });
    }
}
module.exports = { print, getPropertyDescriptor, DeprecationError, _aws_cdk_aws_comprehend_CfnFlywheelProps, _aws_cdk_aws_comprehend_CfnFlywheel, _aws_cdk_aws_comprehend_CfnFlywheel_DataSecurityConfigProperty, _aws_cdk_aws_comprehend_CfnFlywheel_DocumentClassificationConfigProperty, _aws_cdk_aws_comprehend_CfnFlywheel_EntityRecognitionConfigProperty, _aws_cdk_aws_comprehend_CfnFlywheel_EntityTypesListItemProperty, _aws_cdk_aws_comprehend_CfnFlywheel_TaskConfigProperty, _aws_cdk_aws_comprehend_CfnFlywheel_VpcConfigProperty };
